org.apache.xml.utils

## Class DOMBuilder

- java.lang.Object
- - org.apache.xml.utils.DOMBuilder

All Implemented Interfaces:
  ContentHandler, LexicalHandler

    public class DOMBuilder
    extends java.lang.Object
    implements ContentHandler, LexicalHandler

This class takes SAX events (in addition to some extra events that SAX doesn't handle yet) and adds the result to a document or document fragment.

Usage:

### Field Summary

Fields
`Document` `m_doc` Root document
`DocumentFragment` `m_docFrag` First node of document fragment or null if not a DocumentFragment

### Constructor Summary

Constructors
Constructor and Description
`DOMBuilder(Document doc)` DOMBuilder instance constructor... it will add the DOM nodes to the document.
`DOMBuilder(Document doc, DocumentFragment docFrag)` DOMBuilder instance constructor... it will add the DOM nodes to the document fragment.
`DOMBuilder(Document doc, Node node)` DOMBuilder instance constructor... it will add the DOM nodes to the document fragment.

### Method Summary

Methods
`void` `cdata(char[] ch, int start, int length)` Receive notification of cdata.
`void` `characters(char[] ch, int start, int length)` Receive notification of character data.
`void` `charactersRaw(char[] ch, int start, int length)` If available, when the disable-output-escaping attribute is used, output raw text without escaping.
`void` `comment(char[] ch, int start, int length)` Report an XML comment anywhere in the document.
`void` `endCDATA()` Report the end of a CDATA section.
`void` `endDocument()` Receive notification of the end of a document.
`void` `endDTD()` Report the end of DTD declarations.
`void` `endElement(java.lang.String ns, java.lang.String localName, java.lang.String name)` Receive notification of the end of an element.
`void` `endEntity(java.lang.String name)` Report the end of an entity.
`void` `endPrefixMapping(java.lang.String prefix)` End the scope of a prefix-URI mapping.
`void` `entityReference(java.lang.String name)` Receive notivication of a entityReference.
`Node` `getCurrentNode()` Get the node currently being processed.
`Node` `getNextSibling()` Return the next sibling node.
`Node` `getRootDocument()` Get the root document or DocumentFragment of the DOM being created.
`Node` `getRootNode()` Get the root node of the DOM tree.
`java.io.Writer` `getWriter()` Return null since there is no Writer for this class.
`void` `ignorableWhitespace(char[] ch, int start, int length)` Receive notification of ignorable whitespace in element content.
`void` `processingInstruction(java.lang.String target, java.lang.String data)` Receive notification of a processing instruction.
`void` `setDocumentLocator(Locator locator)` Receive an object for locating the origin of SAX document events.
`void` `setIDAttribute(java.lang.String id, Element elem)` Set an ID string to node association in the ID table.
`void` `setNextSibling(Node nextSibling)` Set the next sibling node, which is where the result nodes should be inserted before.
`void` `skippedEntity(java.lang.String name)` Receive notification of a skipped entity.
`void` `startCDATA()` Report the start of a CDATA section.
`void` `startDocument()` Receive notification of the beginning of a document.
`void` `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report the start of DTD declarations, if any.
`void` `startElement(java.lang.String ns, java.lang.String localName, java.lang.String name, Attributes atts)` Receive notification of the beginning of an element.
`void` `startEntity(java.lang.String name)` Report the beginning of an entity.
`void` `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Begin the scope of a prefix-URI Namespace mapping.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### m_doc

    public Document m_doc

Root document

#### m_docFrag

    public DocumentFragment m_docFrag

First node of document fragment or null if not a DocumentFragment

### Constructor Detail

#### DOMBuilder

    public DOMBuilder(Document doc,
              Node node)

DOMBuilder instance constructor... it will add the DOM nodes to the document fragment.

Parameters:
  `doc` - Root document
  `node` - Current node

#### DOMBuilder

    public DOMBuilder(Document doc,
              DocumentFragment docFrag)

DOMBuilder instance constructor... it will add the DOM nodes to the document fragment.

Parameters:
  `doc` - Root document
  `docFrag` - Document fragment

#### DOMBuilder

    public DOMBuilder(Document doc)

DOMBuilder instance constructor... it will add the DOM nodes to the document.

Parameters:
  `doc` - Root document

### Method Detail

#### getRootDocument

    public Node getRootDocument()

Get the root document or DocumentFragment of the DOM being created.

Returns:
  The root document or document fragment if not null

#### getRootNode

    public Node getRootNode()

Get the root node of the DOM tree.

#### getCurrentNode

    public Node getCurrentNode()

Get the node currently being processed.

Returns:
  the current node being processed

#### setNextSibling

    public void setNextSibling(Node nextSibling)

Set the next sibling node, which is where the result nodes should be inserted before.

Parameters:
  `nextSibling` - the next sibling node.

#### getNextSibling

    public Node getNextSibling()

Return the next sibling node.

Returns:
  the next sibling node.

#### getWriter

    public java.io.Writer getWriter()

Return null since there is no Writer for this class.

Returns:
  null

#### setDocumentLocator

    public void setDocumentLocator(Locator locator)

Receive an object for locating the origin of SAX document events.

SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the ContentHandler interface.

The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

Specified by:
  `setDocumentLocator` in interface `ContentHandler`
Parameters:
  `locator` - An object that can return the location of any SAX document event.
See Also:
  `Locator`

#### startDocument

    public void startDocument()
                       throws SAXException

Receive notification of the beginning of a document.

The SAX parser will invoke this method only once, before any other methods in this interface or in DTDHandler (except for setDocumentLocator).

Specified by:
  `startDocument` in interface `ContentHandler`
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception
See Also:
  `ContentHandler.endDocument()`

#### endDocument

    public void endDocument()
                     throws SAXException

Receive notification of the end of a document.

The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input.

Specified by:
  `endDocument` in interface `ContentHandler`
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception
See Also:
  `ContentHandler.startDocument()`

#### startElement

    public void startElement(java.lang.String ns,
                    java.lang.String localName,
                    java.lang.String name,
                    Attributes atts)
                      throws SAXException

Receive notification of the beginning of an element.

The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event.

If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted.

Specified by:
  `startElement` in interface `ContentHandler`
Parameters:
  `ns` - The namespace of the node
  `localName` - The local part of the qualified name
  `name` - The element name.
  `atts` - The attributes attached to the element, if any.
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception
See Also:
  `endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`

#### endElement

    public void endElement(java.lang.String ns,
                  java.lang.String localName,
                  java.lang.String name)
                    throws SAXException

Receive notification of the end of an element.

The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty).

If the element name has a namespace prefix, the prefix will still be attached to the name.

Specified by:
  `endElement` in interface `ContentHandler`
Parameters:
  `ns` - the namespace of the element
  `localName` - The local part of the qualified name of the element
  `name` - The element name
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception

#### setIDAttribute

    public void setIDAttribute(java.lang.String id,
                      Element elem)

Set an ID string to node association in the ID table.

Parameters:
  `id` - The ID string.
  `elem` - The associated ID.

#### characters

    public void characters(char[] ch,
                  int start,
                  int length)
                    throws SAXException

Receive notification of character data.

The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

The application must not attempt to read from the array outside of the specified range.

Note that some parsers will report whitespace using the ignorableWhitespace() method rather than this one (validating parsers must do so).

Specified by:
  `characters` in interface `ContentHandler`
Parameters:
  `ch` - The characters from the XML document.
  `start` - The start position in the array.
  `length` - The number of characters to read from the array.
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception
See Also:
  `ignorableWhitespace(char[], int, int)`, `Locator`

#### charactersRaw

    public void charactersRaw(char[] ch,
                     int start,
                     int length)
                       throws SAXException

If available, when the disable-output-escaping attribute is used, output raw text without escaping. A PI will be inserted in front of the node with the name "lotusxsl-next-is-raw" and a value of "formatter-to-dom".

Parameters:
  `ch` - Array containing the characters
  `start` - Index to start of characters in the array
  `length` - Number of characters in the array
Throws:
  `SAXException`

#### startEntity

    public void startEntity(java.lang.String name)
                     throws SAXException

Report the beginning of an entity. The start and end of the document entity are not reported. The start and end of the external DTD subset are reported using the pseudo-name "[dtd]". All other events must be properly nested within start/end entity events.

Specified by:
  `startEntity` in interface `LexicalHandler`
Parameters:
  `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endEntity(java.lang.String)`, `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`

#### endEntity

    public void endEntity(java.lang.String name)
                   throws SAXException

Report the end of an entity.

Specified by:
  `endEntity` in interface `LexicalHandler`
Parameters:
  `name` - The name of the entity that is ending.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startEntity(java.lang.String)`

#### entityReference

    public void entityReference(java.lang.String name)
                         throws SAXException

Receive notivication of a entityReference.

Parameters:
  `name` - name of the entity reference
Throws:
  `SAXException`

#### ignorableWhitespace

    public void ignorableWhitespace(char[] ch,
                           int start,
                           int length)
                             throws SAXException

Receive notification of ignorable whitespace in element content.

Validating Parsers must use this method to report each chunk of ignorable whitespace (see the W3C XML 1.0 recommendation, section 2.10): non-validating parsers may also use this method if they are capable of parsing and using content models.

SAX parsers may return all contiguous whitespace in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

The application must not attempt to read from the array outside of the specified range.

Specified by:
  `ignorableWhitespace` in interface `ContentHandler`
Parameters:
  `ch` - The characters from the XML document.
  `start` - The start position in the array.
  `length` - The number of characters to read from the array.
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception
See Also:
  `characters(char[], int, int)`

#### processingInstruction

    public void processingInstruction(java.lang.String target,
                             java.lang.String data)
                               throws SAXException

Receive notification of a processing instruction.

The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element.

A SAX parser should never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method.

Specified by:
  `processingInstruction` in interface `ContentHandler`
Parameters:
  `target` - The processing instruction target.
  `data` - The processing instruction data, or null if none was supplied.
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception

#### comment

    public void comment(char[] ch,
               int start,
               int length)
                 throws SAXException

Report an XML comment anywhere in the document. This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read).

Specified by:
  `comment` in interface `LexicalHandler`
Parameters:
  `ch` - An array holding the characters in the comment.
  `start` - The starting position in the array.
  `length` - The number of characters to use from the array.
Throws:
  `SAXException` - The application may raise an exception.

#### startCDATA

    public void startCDATA()
                    throws SAXException

Report the start of a CDATA section.

Specified by:
  `startCDATA` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endCDATA()`

#### endCDATA

    public void endCDATA()
                  throws SAXException

Report the end of a CDATA section.

Specified by:
  `endCDATA` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startCDATA()`

#### cdata

    public void cdata(char[] ch,
             int start,
             int length)
               throws SAXException

Receive notification of cdata.

The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

The application must not attempt to read from the array outside of the specified range.

Note that some parsers will report whitespace using the ignorableWhitespace() method rather than this one (validating parsers must do so).

Parameters:
  `ch` - The characters from the XML document.
  `start` - The start position in the array.
  `length` - The number of characters to read from the array.
Throws:
  `SAXException`
See Also:
  `ignorableWhitespace(char[], int, int)`, `Locator`

#### startDTD

    public void startDTD(java.lang.String name,
                java.lang.String publicId,
                java.lang.String systemId)
                  throws SAXException

Report the start of DTD declarations, if any. Any declarations are assumed to be in the internal subset unless otherwise indicated.

Specified by:
  `startDTD` in interface `LexicalHandler`
Parameters:
  `name` - The document type name.
  `publicId` - The declared public identifier for the external DTD subset, or null if none was declared.
  `systemId` - The declared system identifier for the external DTD subset, or null if none was declared.
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `endDTD()`, `startEntity(java.lang.String)`

#### endDTD

    public void endDTD()
                throws SAXException

Report the end of DTD declarations.

Specified by:
  `endDTD` in interface `LexicalHandler`
Throws:
  `SAXException` - The application may raise an exception.
See Also:
  `startDTD(java.lang.String, java.lang.String, java.lang.String)`

#### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                          java.lang.String uri)
                            throws SAXException

Begin the scope of a prefix-URI Namespace mapping.

The information from this event is not necessary for normal Namespace processing: the SAX XML reader will automatically replace prefixes for element and attribute names when the http://xml.org/sax/features/namespaces feature is true (the default).

There are cases, however, when applications need to use prefixes in character data or in attribute values, where they cannot safely be expanded automatically; the start/endPrefixMapping event supplies the information to the application to expand prefixes in those contexts itself, if necessary.

Note that start/endPrefixMapping events are not guaranteed to be properly nested relative to each-other: all startPrefixMapping events will occur before the corresponding startElement event, and all endPrefixMapping events will occur after the corresponding endElement event, but their order is not guaranteed.

Specified by:
  `startPrefixMapping` in interface `ContentHandler`
Parameters:
  `prefix` - The Namespace prefix being declared.
  `uri` - The Namespace URI the prefix is mapped to.
Throws:
  `SAXException` - the client may throw an exception during processing
See Also:
  `endPrefixMapping(java.lang.String)`, `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

#### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)
                          throws SAXException

End the scope of a prefix-URI mapping.

See startPrefixMapping for details. This event will always occur after the corresponding endElement event, but the order of endPrefixMapping events is not otherwise guaranteed.

Specified by:
  `endPrefixMapping` in interface `ContentHandler`
Parameters:
  `prefix` - The prefix that was being mapping.
Throws:
  `SAXException` - the client may throw an exception during processing
See Also:
  `startPrefixMapping(java.lang.String, java.lang.String)`, `endElement(java.lang.String, java.lang.String, java.lang.String)`

#### skippedEntity

    public void skippedEntity(java.lang.String name)
                       throws SAXException

Receive notification of a skipped entity.

The Parser will invoke this method once for each entity skipped. Non-validating processors may skip entities if they have not seen the declarations (because, for example, the entity was declared in an external DTD subset). All processors may skip external entities, depending on the values of the http://xml.org/sax/features/external-general-entities and the http://xml.org/sax/features/external-parameter-entities properties.

Specified by:
  `skippedEntity` in interface `ContentHandler`
Parameters:
  `name` - The name of the skipped entity. If it is a parameter entity, the name will begin with '%'.
Throws:
  `SAXException` - any SAX exception, possibly wrapping another exception